use crate::{
    request::Request,
    response::Response,
};
use std::io::{Read, Write};
pub use self::{error::Error, verifier::{CertificateStore, Verifier}};

mod error;
mod verifier;

#[derive(Debug)]
pub struct Sender<S, C, T>
where
    S: CertificateStore,
    C: Sized,
    T: Read + Write + Sized,
{
    pub request: Request,
    pub verifier: Verifier<S>,
    pub stream: rustls::StreamOwned<C, T>,
}

impl<S, C, T> Sender<S, C, T>
where
    S: CertificateStore,
    C: Sized,
    T: Read + Write + Sized,
{
    pub fn new(request_str: &str, store: S) -> Result<Self, Error> {
        let request: Request = request_str.parse()?;
        let verifier = Verifier::new(store);
        unimplemented!();
    }

    pub fn send(&mut self) -> Result<Response, Error> {
        unimplemented!();
    }
}
